/*
 *  Scheduler.cpp
 *  ProgrammazioneAOggetti
 *
 *  Created by Michele Mastrogiovanni Second on 05/12/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include "Event.h"
#include "Scheduler.h"

Scheduler* Scheduler::instance_ = NULL;

Scheduler::Scheduler() 
{
	now_ = 0.0;
}

Scheduler & 
Scheduler::instance()
{
	if ( instance_ == NULL )
		instance_ = new Scheduler();
	return *instance_;
}

bool 
Scheduler::dispatch()
{
	if ( events_.size() == 0 )
		return false;
	EventSet::iterator first = events_.begin();
	Event * e = (*first);
	events_.erase( first );
	now_ = e -> getTime();
	e -> getHandler() -> handle( e );
	return true;
}

void
Scheduler::schedule( Event * event, Handler * handler, float delta )
{
	// cout << "Inserting" << endl;
	event -> setTime( now_ + delta );
	event -> setHandler( handler );
	events_.insert( event );
}

void
Scheduler::flush()
{
	for ( EventSet::iterator i = events_.begin(); i != events_.end(); i ++ ) {
		// printf( "Flushed\n" );
		delete( *i );
	}
}
