/*
 *  Scheduler.h
 *  ProgrammazioneAOggetti
 *
 *  Created by Michele Mastrogiovanni Second on 05/12/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include <set>
#include <iostream>

#include "Handler.h"
#include "Event.h"

using namespace std;

#ifndef _SCHEDULER_H_
#define _SCHEDULER_H_

struct EventComp
{
	bool operator()( const Event * e1, const Event * e2 ) const {
		return e1 -> operator<( *e2 );
	}
};

typedef set< Event*, EventComp > EventSet;

class Scheduler {
public:
	static Scheduler & instance();
	bool dispatch();
	void schedule( Event * event, Handler * handler, float delta );
	void flush();

protected:
	float now_;
	EventSet events_;

protected:
	Scheduler();
	static Scheduler * instance_;

};

#endif
